---
title: <feDiffuseLighting>
slug: Web/SVG/Element/feDiffuseLighting
tags:
  - Element
  - SVG
  - SVG Filter
---
<div>{{SVGRef}}</div>

<p>The <strong><code>&lt;feDiffuseLighting&gt;</code></strong> <a href="/en-US/docs/Web/SVG">SVG</a> filter primitive lights an image using the alpha channel as a bump map. The resulting image, which is an RGBA opaque image, depends on the light color, light position and surface geometry of the input bump map.</p>

<p>The light map produced by this filter primitive can be combined with a texture image using the multiply term of the <code>arithmetic</code> operator of the {{SVGElement("feComposite")}} filter primitive. Multiple light sources can be simulated by adding several of these light maps together before applying it to the texture image.</p>

<h2 id="Usage_context">Usage context</h2>

<p>{{svginfo}}</p>

<h2 id="Attributes">Attributes</h2>

<h3 id="Global_attributes">Global attributes</h3>

<ul>
 <li><a href="/en-US/docs/Web/SVG/Attribute#Core_attributes">Core attributes</a></li>
 <li><a href="/en-US/docs/Web/SVG/Attribute#Presentation_attributes">Presentation attributes</a></li>
 <li><a href="/en-US/docs/Web/SVG/Attribute#Filter_primitive_attributes">Filter primitive attributes</a></li>
 <li>{{SVGAttr("class")}}</li>
 <li>{{SVGAttr("style")}}</li>
</ul>

<h3 id="Specific_attributes">Specific attributes</h3>

<ul>
 <li>{{SVGAttr("in")}}</li>
 <li>{{SVGAttr("surfaceScale")}}</li>
 <li>{{SVGAttr("diffuseConstant")}}</li>
 <li>{{SVGAttr("kernelUnitLength")}}</li>
</ul>

<h2 id="DOM_Interface">DOM Interface</h2>

<p>This element implements the {{domxref("SVGFEDiffuseLightingElement")}} interface.</p>

<h2 id="Example">Example</h2>

<p>The following example show the effect of the <code>&lt;feDiffuseLighting&gt;</code> element on a circle with each light source available. Each time, the light comes from the upper left corner.</p>

<pre class="brush: html; highlight[10-13,25-28,40-44]">&lt;svg width="440" height="140" xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;!-- No light is applied --&gt;
  &lt;text text-anchor="middle" x="60" y="22"&gt;No Light&lt;/text&gt;
  &lt;circle cx="60" cy="80" r="50" fill="green" /&gt;

  &lt;!-- the light source is a fePointLight element --&gt;
  &lt;text text-anchor="middle" x="170" y="22"&gt;fePointLight&lt;/text&gt;
  &lt;filter id="lightMe1"&gt;
    &lt;feDiffuseLighting in="SourceGraphic" result="light"
        lighting-color="white"&gt;
      &lt;fePointLight x="150" y="60" z="20" /&gt;
    &lt;/feDiffuseLighting&gt;

    &lt;feComposite in="SourceGraphic" in2="light"
                 operator="arithmetic" k1="1" k2="0" k3="0" k4="0"/&gt;
  &lt;/filter&gt;

  &lt;circle cx="170" cy="80" r="50" fill="green"
      filter="url(#lightMe1)" /&gt;

  &lt;!-- the light source is a feDistantLight element --&gt;
  &lt;text text-anchor="middle" x="280" y="22"&gt;feDistantLight&lt;/text&gt;
  &lt;filter id="lightMe2"&gt;
    &lt;feDiffuseLighting in="SourceGraphic" result="light"
        lighting-color="white"&gt;
      &lt;feDistantLight azimuth="240" elevation="20"/&gt;
    &lt;/feDiffuseLighting&gt;

    &lt;feComposite in="SourceGraphic" in2="light"
                 operator="arithmetic" k1="1" k2="0" k3="0" k4="0"/&gt;
  &lt;/filter&gt;

  &lt;circle cx="280" cy="80" r="50" fill="green"
      filter="url(#lightMe2)" /&gt;

  &lt;!-- the light source is a feSpotLight source --&gt;
  &lt;text text-anchor="middle" x="390" y="22"&gt;feSpotLight&lt;/text&gt;
  &lt;filter id="lightMe3"&gt;
    &lt;feDiffuseLighting in="SourceGraphic" result="light"
        lighting-color="white"&gt;
      &lt;feSpotLight x="360" y="5" z="30" limitingConeAngle="20"
                   pointsAtX="390" pointsAtY="80" pointsAtZ="0"/&gt;
    &lt;/feDiffuseLighting&gt;

    &lt;feComposite in="SourceGraphic" in2="light"
                 operator="arithmetic" k1="1" k2="0" k3="0" k4="0"/&gt;
  &lt;/filter&gt;

  &lt;circle cx="390" cy="80" r="50" fill="green"
      filter="url(#lightMe3)" /&gt;
&lt;/svg&gt;</pre>

<p>Expected rendering:</p>

<p><img alt="Expected rendering for the example" src="/files/4447/feDiffuseLighting.png"></p>

<p>Live rendering:</p>

<p>{{EmbedLiveSample("Example", 470, 170)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Filters 1.0', '#feDiffuseLightingElement', '&lt;feDiffuseLighting&gt;')}}</td>
   <td>{{Spec2('Filters 1.0')}}</td>
   <td>Deprecated <code>kernelUnitLength</code> attribute</td>
  </tr>
  <tr>
   <td>{{SpecName('SVG1.1', 'filters.html#feDiffuseLightingElement', '&lt;feDiffuseLighting&gt;')}}</td>
   <td>{{Spec2('SVG1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.elements.feDiffuseLighting")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SVGElement("filter")}}</li>
 <li>{{SVGElement("feBlend")}}</li>
 <li>{{SVGElement("feColorMatrix")}}</li>
 <li>{{SVGElement("feComponentTransfer")}}</li>
 <li>{{SVGElement("feComposite")}}</li>
 <li>{{SVGElement("feConvolveMatrix")}}</li>
 <li>{{SVGElement("feDisplacementMap")}}</li>
 <li>{{SVGElement("feDistantLight")}}</li>
 <li>{{SVGElement("feFlood")}}</li>
 <li>{{SVGElement("feGaussianBlur")}}</li>
 <li>{{SVGElement("feImage")}}</li>
 <li>{{SVGElement("feMerge")}}</li>
 <li>{{SVGElement("feMorphology")}}</li>
 <li>{{SVGElement("feOffset")}}</li>
 <li>{{SVGElement("fePointLight")}}</li>
 <li>{{SVGElement("feSpecularLighting")}}</li>
 <li>{{SVGElement("feSpotLight")}}</li>
 <li>{{SVGElement("feTile")}}</li>
 <li>{{SVGElement("feTurbulence")}}</li>
 <li><a href="/en-US/docs/Web/SVG/Tutorial/Filter_effects">SVG tutorial: Filter effects</a></li>
</ul>
